#include <kernel.hpp>

// ƥ

ER Kernel::getTime(SYSTIM *p_systim)
{
  return ::get_tim(p_systim);
}

ER Kernel::setTime(SYSTIM *p_systim)
{
  return ::set_tim(p_systim);
}

ER Kernel::iSignalTime()
{
  return ::isig_tim();
}


// ƥִǽ

ER Kernel::rotateReadyQueue(PRI tskpri)
{
  return ::rot_rdq(tskpri);
}

ER Kernel::iRotateReadyQueue(PRI tskpri)
{
  return ::irot_rdq(tskpri);
}

ER Kernel::getRunningTaskID(ID *p_tskid)
{
  return ::get_tid(p_tskid);
}

ER Kernel::iGetRunningTaskID(ID *p_tskid)
{
  return ::iget_tid (p_tskid);
}

ER Kernel::lockCPU()
{
  return ::loc_cpu();
}

ER Kernel::iLockCPU()
{
  return ::iloc_cpu();
}

ER Kernel::unlockCPU()
{
  return ::unl_cpu();
}

ER Kernel::iUnlockCPU()
{
  return ::iunl_cpu();
}

ER Kernel::disableDispatch()
{
  return ::dis_dsp();
}

ER Kernel::enableDispatch()
{
  return ::ena_dsp();
}

BOOL Kernel::senseContext()
{
  return ::sns_ctx();
}

BOOL Kernel::senseLock()
{
  return ::sns_loc();
}

BOOL Kernel::senseDispatch()
{
  return ::sns_dsp();
}

BOOL Kernel::senseDispatchPending()
{
  return ::sns_dpn();
}
