#include <kernel.hpp>

Task::Task(ID id) : tskid(id)
  // IDֹΥå [S]
{
  /* Nothing to do... */
}


// IDֹμ

inline ID Task::getId()
{
  return tskid;
}


// ǽ

ER Task::activate()
{
  return ::act_tsk(tskid);
}

ER Task::iActivate()
{
  return ::iact_tsk(tskid);
}

ER Task::cancelActivate()
{
  return ::can_act(tskid);
}

ER Task::terminate()
{
  return ::ter_tsk(tskid);
}

ER Task::changePriority(PRI tskpri)
{
  return ::chg_pri(tskid, tskpri);
}

ER Task::getPriority(PRI *p_tskpri)
{
  return ::get_pri(tskid, p_tskpri);
}


// °Ʊǽ

ER Task::wakeup()
{
  return ::wup_tsk(tskid);
}

ER Task::iWakeup()
{
  return ::iwup_tsk(tskid);
}

ER_UINT Task::cancelWakeup()
{
  return ::can_wup(tskid);
}

ER Task::releaseWait()
{
  return ::rel_wai(tskid);
}

ER Task::iReleaseWait()
{
  return ::irel_wai(tskid);
}

ER Task::suspend()
{
  return ::sus_tsk(tskid);
}

ER Task::resume()
{
  return ::rsm_tsk(tskid);
}

ER Task::forceResume()
{
  return ::frsm_tsk(tskid);
}


// 㳰ǽ

ER Task::raiseTaskException(TEXPTN rasptn)
{
  return ::ras_tex(tskid, rasptn);
}

ER Task::iRaiseTaskException(TEXPTN rasptn)
{
  return ::iras_tex(tskid, rasptn);
}


// ʲϼоݤȤ륵ӥʥ饹᥽åɡ


// ǽ

void Task::exit()
{
  return ::ext_tsk();
}


// °Ʊǽ

ER Task::sleep()
{
  return ::slp_tsk();
}

ER Task::sleep(TMO tmo)
{
  return ::tslp_tsk(tmo);
}

ER Task::delay(RELTIM dlytim)
{
  return ::dly_tsk(dlytim);
}


// 㳰ǽ

ER Task::disableTaskException()
{
  return ::dis_tex();
}

ER Task::enableTaskException()
{
  return ::ena_tex();
}

BOOL Task::senseTaskException()
{
  return ::sns_tex();
}
